package gregapi;

import static gregapi.data.CS.*;
import gregapi.api.Abstract_Mod;
import gregapi.api.Abstract_Proxy;
import gregapi.code.HashSetNoNulls;
import gregapi.data.*;
import gregapi.data.CS.BlocksGT;
import gregapi.data.CS.ModIDs;
import gregapi.data.CS.PlankData;
import gregapi.load.LoaderBookList;
import gregapi.load.LoaderItemData;
import gregapi.load.LoaderItemList;
import gregapi.load.LoaderUnificationTargets;
import gregapi.oredict.OreDictManager;
import gregapi.oredict.OreDictMaterial;
import gregapi.recipes.Recipe;
import gregapi.util.OM;
import gregapi.util.ST;
import gregapi.util.UT;

import java.util.ArrayList;
import java.util.List;

import net.minecraft.block.Block;
import net.minecraft.init.Blocks;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.CraftingManager;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.util.WeightedRandomChestContent;
import net.minecraftforge.common.ChestGenHooks;
import net.minecraftforge.oredict.ShapedOreRecipe;
import net.minecraftforge.oredict.ShapelessOreRecipe;
import cpw.mods.fml.common.*;
import cpw.mods.fml.common.event.*;

/**
 * @author Gregorius Techneticies
 * 
 * This loads after the compatible Mods. The regular API loads before all compatible Mods.
 */
@Mod(modid=ModIDs.GAPI_POST, name="Greg-API-Post", version="GT6-MC1710", dependencies="required-after:"+ModIDs.GAPI+"; after:"+ModIDs.IC2+"; after:"+ModIDs.IC2C+"; after:"+ModIDs.NC+"; after:"+ModIDs.IHL+"; after:"+ModIDs.FMB+"; after:"+ModIDs.GaSu+"; after:"+ModIDs.GaNe+"; after:"+ModIDs.GaEn+"; after:"+ModIDs.CrGu+"; after:"+ModIDs.COFH_API+"; after:"+ModIDs.COFH_API_ENERGY+"; after:"+ModIDs.CC+"; after:"+ModIDs.OC+"; after:"+ModIDs.DE+"; after:"+ModIDs.FR+"; after:"+ModIDs.BINNIE+"; after:"+ModIDs.BINNIE_BEE+"; after:"+ModIDs.BINNIE_TREE+"; after:"+ModIDs.BINNIE_GENETICS+"; after:"+ModIDs.BINNIE_BOTANY+"; after:"+ModIDs.IE+"; after:"+ModIDs.UB+"; after:"+ModIDs.PFAA+"; after:"+ModIDs.ARS+"; after:"+ModIDs.TC+"; after:"+ModIDs.TCFM+"; after:"+ModIDs.BOTA+"; after:"+ModIDs.WTCH+"; after:"+ModIDs.HOWL+"; after:"+ModIDs.MoCr+"; after:"+ModIDs.RC+"; after:"+ModIDs.BP+"; after:"+ModIDs.PR+"; after:"+ModIDs.PR_EXPANSION+"; after:"+ModIDs.PR_INTEGRATION+"; after:"+ModIDs.PR_TRANSMISSION+"; after:"+ModIDs.PR_TRANSPORT+"; after:"+ModIDs.PE+"; after:"+ModIDs.AE+"; after:"+ModIDs.MO+"; after:"+ModIDs.TE_FOUNDATION+"; after:"+ModIDs.TE_DYNAMICS+"; after:"+ModIDs.TE+"; after:"+ModIDs.CHSL+"; after:"+ModIDs.EtFu+"; after:"+ModIDs.BbLC+"; after:"+ModIDs.TF+"; after:"+ModIDs.MFR+"; after:"+ModIDs.PnC+"; after:"+ModIDs.ExU+"; after:"+ModIDs.EIO+"; after:"+ModIDs.RT+"; after:"+ModIDs.AA+"; after:"+ModIDs.HaC+"; after:"+ModIDs.APC+"; after:"+ModIDs.ENVM+"; after:"+ModIDs.MaCr+"; after:"+ModIDs.BC_TRANSPORT+"; after:"+ModIDs.BC_SILICON+"; after:"+ModIDs.BC_FACTORY+"; after:"+ModIDs.BC_ENERGY+"; after:"+ModIDs.BC_ROBOTICS+"; after:"+ModIDs.BC+"; after:"+ModIDs.BC_BUILDERS+"; after:"+ModIDs.MgC+"; after:"+ModIDs.BR+"; after:"+ModIDs.DRGN+"; after:"+ModIDs.ElC+"; after:"+ModIDs.CrC+"; after:"+ModIDs.ReC+"; after:"+ModIDs.RoC+"; after:"+ModIDs.Mek+"; after:"+ModIDs.Mek_Tools+"; after:"+ModIDs.Mek_Generators+"; after:"+ModIDs.MD8+"; after:"+ModIDs.GC+"; after:"+ModIDs.GC_PLANETS+"; after:"+ModIDs.GC_GALAXYSPACE+"; after:"+ModIDs.VULPES+"; after:"+ModIDs.GC_ADV_ROCKETRY+"; after:"+ModIDs.ATUM+"; after:"+ModIDs.EBXL+"; after:"+ModIDs.BoP+"; after:"+ModIDs.ATG+"; after:"+ModIDs.MYST+"; after:"+ModIDs.WARPBOOK+"; after:"+ModIDs.LOSTBOOKS+"; after:"+ModIDs.EUREKA+"; after:"+ModIDs.ENCHIRIDION+"; after:"+ModIDs.ENCHIRIDION2+"; after:"+ModIDs.SmAc+"; after:"+ModIDs.HQM+"; after:"+ModIDs.JABBA+"; after:"+ModIDs.MaCu+"; after:"+ModIDs.PdC+"; after:"+ModIDs.Bamboo+"; after:"+ModIDs.GrC+"; after:"+ModIDs.GrC_Apples+"; after:"+ModIDs.GrC_Bamboo+"; after:"+ModIDs.GrC_Bees+"; after:"+ModIDs.GrC_Cellar+"; after:"+ModIDs.GrC_Fish+"; after:"+ModIDs.GrC_Grapes+"; after:"+ModIDs.GrC_Hops+"; after:"+ModIDs.GrC_Milk+"; after:"+ModIDs.GrC_Rice+"; after:"+ModIDs.BWM+"; after:"+ModIDs.FZ+"; after:"+ModIDs.MNTL+"; after:"+ModIDs.OB+"; after:"+ModIDs.TiC+";")
public class GT_API_Post extends Abstract_Mod {
	public GT_API_Post() {GAPI_POST = this;}
	
	@Override public String getModID() {return MD.GAPI_POST.mID;}
	@Override public String getModName() {return MD.GAPI_POST.mName;}
	@Override public String getModNameForLog() {return "GT_API_POST";}
	@Override public Abstract_Proxy getProxy() {return null;}
	
	@Mod.EventHandler public final void onPreLoad			(FMLPreInitializationEvent	aEvent) {onModPreInit(aEvent);}
	@Mod.EventHandler public final void onLoad				(FMLInitializationEvent		aEvent) {onModInit(aEvent);}
	@Mod.EventHandler public final void onPostLoad			(FMLPostInitializationEvent	aEvent) {onModPostInit(aEvent);}
	@Mod.EventHandler public final void onServerStarting	(FMLServerStartingEvent		aEvent) {onModServerStarting(aEvent);}
	@Mod.EventHandler public final void onServerStarted		(FMLServerStartedEvent		aEvent) {onModServerStarted(aEvent);}
	@Mod.EventHandler public final void onServerStopping	(FMLServerStoppingEvent		aEvent) {onModServerStopping(aEvent);}
	@Mod.EventHandler public final void onServerStopped		(FMLServerStoppedEvent		aEvent) {onModServerStopped(aEvent);}
	
	@Override
	public void onModPreInit2(FMLPreInitializationEvent aEvent) {
		try {
			OUT.println(getModNameForLog() + ": Sorting Greg-API-Post to the end of the Mod List for further processing.");
			LoadController tLoadController = ((LoadController)UT.Reflection.getFieldContent(Loader.instance(), "modController", T, T));
			List<ModContainer> tModList = tLoadController.getActiveModList(), tNewModsList = new ArrayList<ModContainer>(tModList.size());
			ModContainer tGregTech = null;
			for (short i = 0; i < tModList.size(); i++) {
				ModContainer tMod = tModList.get(i);
				if (tMod.getModId().equalsIgnoreCase(MD.GAPI_POST.mID)) tGregTech = tMod; else tNewModsList.add(tMod);
			}
			if (tGregTech != null) tNewModsList.add(tGregTech);
			UT.Reflection.getField(tLoadController, "activeModList", T, T).set(tLoadController, tNewModsList);
		} catch(Throwable e) {
			if (D1) e.printStackTrace(ERR);
		}
		
		// Fixing Items of certain Mods.
		for (Item tItem : new Item[] {
		  ST.item(MD.GrC_Grapes, "grc.grapes")
		, ST.item(MD.FR, "letters")
		, ST.item(MD.FZ, "acid")
		}) if (tItem != null) tItem.setMaxDamage(0).setHasSubtypes(T);
		
		new LoaderItemList().run();
		new LoaderItemData().run();
		new LoaderUnificationTargets().run();
		
		if (MD.TiC.mLoaded) MT.Co.addOreByProducts(MT.Ardite);
		
		if (MD.BR.mLoaded) {
			MT.Th.addOreByProducts(MT.Cyanite);
			MT.Monazite.addOreByProducts(MT.Cyanite);
			MT.Forcicium.addOreByProducts(MT.Cyanite);
			MT.Forcillium.addOreByProducts(MT.Cyanite);
			MT.OREMATS.Pitchblende.addOreByProducts(MT.Yellorium);
			MT.OREMATS.Uraninite.addOreByProducts(MT.Yellorium);
			MT.U_238.addOreByProducts(MT.Yellorium);
			MT.Pu.addOreByProducts(MT.Blutonium);
			MT.Am.addOreByProducts(MT.Blutonium);
		}
		
		// Initialising the List of Decorative Planks
		Block
		tBlock = Blocks.planks;
		for (int i = 0; i <  6; i++) PlankData.PLANKS[   i] = ST.make(tBlock, 1, i);
		tBlock = ST.block(MD.FR, "planks");
		for (int i = 0; i < 29; i++) PlankData.PLANKS[ 8+i] = ST.make(tBlock, 1, i);
		tBlock = ST.block(MD.IE, "treatedWood");
		for (int i = 0; i <  3; i++) PlankData.PLANKS[40+i] = ST.make(tBlock, 1, i);
		tBlock = ST.block(MD.TCFM, "TaintPlank");
		for (int i = 0; i <  1; i++) PlankData.PLANKS[43+i] = ST.make(tBlock, 1, i);
		tBlock = ST.block(MD.MoCr, "MoCWoodPlank");
		for (int i = 0; i <  2; i++) PlankData.PLANKS[44+i] = ST.make(tBlock, 1, i);
		tBlock = ST.block(MD.TC, "blockWoodenDevice");
		for (int i = 0; i <  2; i++) PlankData.PLANKS[46+i] = ST.make(tBlock, 1, i+6);
		tBlock = ST.block(MD.BOTA, "livingwood");
		for (int i = 0; i <  6; i++) PlankData.PLANKS[48+i] = ST.make(tBlock, 1, i);
		tBlock = ST.block(MD.BOTA, "dreamwood");
		for (int i = 0; i <  6; i++) PlankData.PLANKS[56+i] = ST.make(tBlock, 1, i);
		tBlock = ST.block(MD.BOTA, "shimmerwoodPlanks");
		for (int i = 0; i <  1; i++) PlankData.PLANKS[64+i] = ST.make(tBlock, 1, i);
		tBlock = ST.block(MD.WTCH, "witchwood");
		for (int i = 0; i <  3; i++) PlankData.PLANKS[65+i] = ST.make(tBlock, 1, i);
		tBlock = ST.block(MD.TF, "tile.TFTowerStone");
		for (int i = 0; i <  4; i++) PlankData.PLANKS[68+i] = ST.make(tBlock, 1, i);
		tBlock = ST.block(MD.BoP, "planks");
		for (int i = 0; i < 15; i++) PlankData.PLANKS[72+i] = ST.make(tBlock, 1, i);
		tBlock = ST.block(MD.EBXL, "planks");
		for (int i = 0; i <  9; i++) PlankData.PLANKS[87+i] = ST.make(tBlock, 1, i);
		tBlock = ST.block(MD.RC, "cube");
		for (int i = 0; i <  1; i++) PlankData.PLANKS[96+i] = ST.make(tBlock, 1, 8);
	}
	
	@Override
	public void onModInit2(FMLInitializationEvent aEvent) {
		// Atum violates the "Items have to be created in preInit" Rule...
		OM.reg("cropDate"				, ST.make(MD.ATUM, "item.date", 1, 0));
		OM.reg("cropFlax"				, ST.make(MD.ATUM, "item.flax", 1, 0));
		OM.reg("seedFlax"				, ST.make(MD.ATUM, "item.flaxSeeds", 1, 0));
    	OM.reg("itemPelt"				, ST.make(MD.ATUM, "item.wolfPelt", 1, 0));
		OM.reg(OP.stone, MT.Limestone	, ST.make(MD.ATUM, "tile.stone", 1, W));
		OM.reg(OP.stone, MT.Limestone	, ST.make(MD.ATUM, "tile.cobble", 1, W));
		
		
		// And Project Red violates that Rule aswell...
		OreDictManager.INSTANCE.setTarget(OP.ingot	, MT.RedAlloy					, ST.make(MD.PR, "projectred.core.part", 1, 10));
		OreDictManager.INSTANCE.setTarget(OP.ingot	, MT.ElectrotineAlloy			, ST.make(MD.PR, "projectred.core.part", 1, 55));
		OreDictManager.INSTANCE.setTarget(OP.dust	, MT.Electrotine				, ST.make(MD.PR, "projectred.core.part", 1, 56));
		
		
		// Okay I should not have wondered about Blue Power doing the same garbage considering Project Red...
		OreDictManager.INSTANCE.setTarget(OP.ingot	, MT.RedAlloy					, ST.make(MD.BP, "red_alloy_ingot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot	, MT.BlueAlloy					, ST.make(MD.BP, "blue_alloy_ingot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot	, MT.PurpleAlloy				, ST.make(MD.BP, "purple_alloy_ingot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust	, MT.Teslatite					, ST.make(MD.BP, "teslatite_dust", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust	, MT.UNUSED.InfusedTeslatite	, ST.make(MD.BP, "infused_teslatite_dust", 1, 0));
		OM.reg("seedFlax"															, ST.make(MD.BP, "flax_seeds", 1, 0));
		OM.reg(DYE_OREDICTS_MIXABLE[DYE_INDEX_Purple]								, ST.make(MD.BP, "indigo_dye", 1, 0));
		OM.reg("cropIndigo"															, ST.make(MD.BP, "indigo_flower", 1, 0));
		OM.reg(OP.dustTiny.dat(MT.Zn)												, ST.make(MD.BP, "zinc_tiny_dust", 1, 0));
		OM.reg(OP.crushed.dat(MT.Zn)												, ST.make(MD.BP, "zinc_ore_crushed", 1, 0));
		OM.reg(OP.crushedPurified.dat(MT.Zn)										, ST.make(MD.BP, "zinc_ore_purified", 1, 0));
		OM.reg(OP.boule.dat(MT.Si)													, ST.make(MD.BP, "silicon_boule", 1, 0));
		
		
		// Oh look, Matter Overdrive does this shit too...
		OreDictManager.INSTANCE.setTarget(OP.gem	, MT.Dilithium					, ST.make(MD.MO, "dilithium_crystal", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust	, MT.TritaniumAlloy				, ST.make(MD.MO, "tritanium_dust", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.nugget	, MT.TritaniumAlloy				, ST.make(MD.MO, "tritanium_nugget", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot	, MT.TritaniumAlloy				, ST.make(MD.MO, "tritanium_ingot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.plate	, MT.TritaniumAlloy				, ST.make(MD.MO, "tritanium_plate", 1, 0));
		
		
		// ThermalExpansion gets on this ShitList too I guess...
		OM.data(MD.TE, "Tank"	, 1,   1, ANY.Cu		,  U * 1, MT.Glass	,  U * 4);
		OM.data(MD.TE, "Tank"	, 1,   2, MT.Invar		,  U * 4, ANY.Cu	,  U * 1, MT.Glass	,  U * 4);
		OM.data(MD.TE, "Tank"	, 1,   3, MT.Invar		,  U * 4, ANY.Cu	,  U * 1, MT.Glass	,  U * 4);
		OM.data(MD.TE, "Tank"	, 1,   4, MT.Enderium	,  U * 4, MT.Invar	,  U * 4, ANY.Cu	,  U * 1, MT.Glass	,  U * 4);
		
		
		// Wow, Ars Magica too is on this List, at least for its Blocks...
		IL.ARS_Cerublossom	.set(ST.make(MD.ARS, "blueOrchid", 1, 0), null, "flowerCerublossom");
		IL.ARS_DesertNova	.set(ST.make(MD.ARS, "desertNova", 1, 0), null, "flowerDesertNova");
	}
	
	@Override
	public void onModPostInit2(FMLPostInitializationEvent aEvent) {
		if (DISABLE_ALL_IC2_COMPRESSOR_RECIPES	) ic2.api.recipe.Recipes.compressor.getRecipes().clear();
		if (DISABLE_ALL_IC2_EXTRACTOR_RECIPES	) ic2.api.recipe.Recipes.extractor .getRecipes().clear();
		if (DISABLE_ALL_IC2_MACERATOR_RECIPES	) ic2.api.recipe.Recipes.macerator .getRecipes().clear();
		if (DISABLE_ALL_IC2_OREWASHER_RECIPES	) ic2.api.recipe.Recipes.oreWashing.getRecipes().clear();
		if (DISABLE_ALL_IC2_CENTRIFUGE_RECIPES	) ic2.api.recipe.Recipes.centrifuge.getRecipes().clear();
		
		if (MD.BoP.mLoaded) {
			BlocksGT.FLOWERS.add(ST.block(MD.BoP, "flowers"));
			BlocksGT.FLOWERS.add(ST.block(MD.BoP, "flowers2"));
		}
		if (MD.EBXL.mLoaded) {
			BlocksGT.FLOWERS.add(ST.block(MD.EBXL, "flower1"));
			BlocksGT.FLOWERS.add(ST.block(MD.EBXL, "flower2"));
			BlocksGT.FLOWERS.add(ST.block(MD.EBXL, "flower3"));
		}
		if (MD.TCFM.mLoaded) {
			BlocksGT.FLOWERS.add(ST.block(MD.TCFM, "InkFlower"));
			BlocksGT.FLOWERS.add(ST.block(MD.TCFM, "UmbralBush"));
		}
		if (MD.BP.mLoaded) {
			BlocksGT.FLOWERS.add(ST.block(MD.BP, "indigo_flower"));
		}
		if (MD.ARS.mLoaded) {
			BlocksGT.FLOWERS.add(ST.block(MD.ARS, "blueOrchid"));
		}
		
		new LoaderBookList().run();
		
		/** Diatomic Elements get a Subscript 2 appended to their ToolTip after PostInit. That way the ToolTip Calculation works properly until PostInit happens. */
		for (OreDictMaterial tMaterial : OreDictMaterial.MATERIAL_MAP.values()) if (tMaterial.contains(TD.Atomic.DIATOMIC_NONMETAL)) tMaterial.mTooltipChemical += "\u2082";
	}
	
	@Override
	public void onModServerStarting2(FMLServerStartingEvent aEvent) {
		if (DISABLE_ALL_IC2_COMPRESSOR_RECIPES	) ic2.api.recipe.Recipes.compressor.getRecipes().clear();
		if (DISABLE_ALL_IC2_EXTRACTOR_RECIPES	) ic2.api.recipe.Recipes.extractor .getRecipes().clear();
		if (DISABLE_ALL_IC2_MACERATOR_RECIPES	) ic2.api.recipe.Recipes.macerator .getRecipes().clear();
		if (DISABLE_ALL_IC2_OREWASHER_RECIPES	) ic2.api.recipe.Recipes.oreWashing.getRecipes().clear();
		if (DISABLE_ALL_IC2_CENTRIFUGE_RECIPES	) ic2.api.recipe.Recipes.centrifuge.getRecipes().clear();
	}
	
	@Override
	public void onModServerStarted2(FMLServerStartedEvent aEvent) {
        OUT.println(getModNameForLog() + ": Re-Unificating Recipes.");
    	Recipe.reInit();
		
    	OUT.println(getModNameForLog() + ": Unificating outputs of all known Recipe Types.");
    	HashSetNoNulls<ItemStack> tStacks = new HashSetNoNulls<ItemStack>(10000);
    	
    	try {
    	OUT.println(getModNameForLog() + ": IC2 Machines");
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.cannerBottle				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.centrifuge				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.compressor				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.extractor					.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.macerator					.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.metalformerCutting		.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.metalformerExtruding		.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.metalformerRolling		.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.matterAmplifier			.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.oreWashing				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	} catch(Throwable e) {/**/}
    	
    	OUT.println(getModNameForLog() + ": Dungeon Loot");
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.DUNGEON_CHEST			).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.BONUS_CHEST				).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.VILLAGE_BLACKSMITH		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.STRONGHOLD_CROSSING		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.STRONGHOLD_LIBRARY		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.STRONGHOLD_CORRIDOR		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_JUNGLE_DISPENSER	).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_JUNGLE_CHEST		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_DESERT_CHEST		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.MINESHAFT_CORRIDOR		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	OUT.println(getModNameForLog() + ": Smelting");
    	for (Object tStack : FurnaceRecipes.smelting().getSmeltingList().values()) tStacks.add((ItemStack)tStack);
    	OUT.println(getModNameForLog() + ": Crafting Recipes");
        for (Object tRecipe : CraftingManager.getInstance().getRecipeList()) if (tRecipe instanceof IRecipe) tStacks.add(((IRecipe)tRecipe).getRecipeOutput());
	    
	    for (ItemStack tOutput : tStacks) {
	    	if (OreDictManager.INSTANCE.isOreDictItem(tOutput)) {
	    		FMLLog.severe("GT-ERR-01: @ " + tOutput.getUnlocalizedName() + "   " + tOutput.getDisplayName());
	    		if (CS.CODE_CLIENT) {
		    		FMLLog.severe("A Recipe used an OreDict Item as Output directly, without copying it before!!! This is a typical CallByReference/CallByValue Error");
		    		FMLLog.severe("Said Item will be renamed to make the invalid Recipe visible, so that you can report it properly.");
		    		FMLLog.severe("Please check all Recipes outputting this Item, and report the Recipes to their Owner.");
		    		FMLLog.severe("The Owner of the ==>RECIPE<==, NOT the Owner of the Item, which has been mentioned above!!!");
		    		FMLLog.severe("And ONLY Recipes which are ==>OUTPUTTING<== the Item, sorry but I don't want failed Bug Reports.");
		    		FMLLog.severe("GregTech just reports this Error to you, so you can report it to the Mod causing the Problem.");
		    		FMLLog.severe("Even though I make that Bug visible, I can not and will not fix that for you, that's for the causing Mod to fix.");
		    		FMLLog.severe("And speaking of failed Reports:");
		    		FMLLog.severe("Both IC2 and GregTech CANNOT be the CAUSE of this Problem, so don't report it to either of them.");
		    		FMLLog.severe("I REPEAT, BOTH, IC2 and GregTech CANNOT be the source of THIS BUG. NO MATTER WHAT.");
		    		FMLLog.severe("Asking in the IC2 Forums, which Mod is causing that, won't help anyone, since it is not possible to determine, which Mod it is.");
		    		FMLLog.severe("If it would be possible, then I would have had added the Mod which is causing it to the Message already. But it is not possible.");
		    		FMLLog.severe("Sorry, but this Error is serious enough to justify this Wall-O-Text and the partially allcapsed Language.");
		    		FMLLog.severe("Also it is a Ban Reason on the IC2-Forums to seriously post this Text. We all know about its existence.");
		    		
		    		tOutput.setStackDisplayName("ERROR!");
		    		UT.NBT.setBoolean(UT.NBT.getNBT(tOutput), "gt.err.oredict.output", T);
	    		}
	    	} else {
		    	OM.set(tOutput);
	    	}
	    }
	    
        OUT.println(getModNameForLog() + ": Cleaning up all OreDict Crafting Recipes, which have an empty List in them, since they are never meeting any Condition.");
        List tList = CraftingManager.getInstance().getRecipeList();
        for (int i = 0; i < tList.size(); i++) {
        	Object tRecipe = tList.get(i);
        	if (tRecipe instanceof ShapedOreRecipe) {
        		Object[] tInput = ((ShapedOreRecipe)tRecipe).getInput();
        		for (int j = 0; j < tInput.length; j++) {
        			if (tInput[j] instanceof List && ((List)tInput[j]).isEmpty()) {
//        				DEB.println("Removed Recipe for " + ((ShapedOreRecipe)tRecipe).getRecipeOutput().getDisplayName() + " because Ingredient Nr. " + j + " is missing");
        				tList.remove(i--);
        				break;
        			}
        		}
        	} else if (tRecipe instanceof ShapelessOreRecipe) {
        		ArrayList<Object> tInput = ((ShapelessOreRecipe)tRecipe).getInput();
        		for (int j = 0; j < tInput.size(); j++) {
        			if (tInput.get(j) instanceof List && ((List)tInput.get(j)).isEmpty()) {
//        				DEB.println("Removed Recipe for " + ((ShapelessOreRecipe)tRecipe).getRecipeOutput().getDisplayName() + " because Ingredient Nr. " + j + " is missing");
        				tList.remove(i--);
        				break;
        			}
        		}
        	}
        }
        
		OreDictManager.INSTANCE.fixStacksizes();
	}
	
	@Override public void onModServerStopping2(FMLServerStoppingEvent aEvent) {/**/}
	@Override public void onModServerStopped2(FMLServerStoppedEvent aEvent) {/**/}
}